<script setup lang="ts">
import { ref } from 'vue';
import Accordion from './../common/Accordion.vue';
import { ChevronLgRight, Quote } from 'slippers-ui/icons';

interface Author {
  name: string;
  title: string;
  company: string;
}

interface CTAConfig {
  href: string;
  dataGaName: string;
  dataGaLocation: string;
}

interface CardConfig {
  logo: string;
}

interface CTA {
  text: string;
  config: CTAConfig;
}

interface Card {
  quote: string;
  author: Author;
  cta: CTA;
  config: CardConfig;
}

interface AccordionItem {
  header: string;
  content: string;
  card: Array<Card>;
}

interface AccordionProps {
  title?: string;
  subtitle?: string;
  accordion: Array<AccordionItem>;
}

defineProps<AccordionProps>();
const isOpenIndex = ref(0);

const toggleController = (index: number) => {
  isOpenIndex.value = index;
};
</script>
<template>
  <section id="accordion-section">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="7">
          <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-32">{{ title }}</SlpTypography>
          <SlpTypography variant="heading5" tag="h5">{{ subtitle }}</SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="accordion__container">
        <SlpColumn :cols="6">
          <div class="accordion__wrapper">
            <Accordion
              v-for="(item, index) in accordion"
              :key="item.header"
              :data="item"
              :is-open="isOpenIndex == index"
              :class="{ active: isOpenIndex === index }"
              @click="toggleController(index)"
            />
          </div>
        </SlpColumn>
        <SlpColumn :cols="6">
          <div class="accordion__card">
            <Transition name="block-fade">
              <div v-if="isOpenIndex !== null">
                <SlpIcon :icon="Quote" size="lg" />
                <div
                  tag="p"
                  variant="body1"
                  class="quote-body slp-mt-16 slp-mb-32"
                  :class="{ active: isOpenIndex !== null }"
                  v-html="$md.render(accordion[isOpenIndex].card[0].quote)"
                ></div>
                <SlpTypography tag="p" variant="body2-bold" class="slp-mb-4">
                  {{ accordion[isOpenIndex].card[0].author.name }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body2">
                  {{ accordion[isOpenIndex].card[0].author.title }}
                  {{
                    accordion[isOpenIndex].card[0].author.company
                      ? `, ${accordion[isOpenIndex].card[0].author.company}`
                      : ''
                  }}
                </SlpTypography>
                <img
                  v-if="accordion[isOpenIndex].card[0].config.logo"
                  :src="accordion[isOpenIndex].card[0].config.logo"
                  :alt="accordion[isOpenIndex].card[0].author.company"
                  class="logo"
                />
                <SlpButton
                  variant="tertiary"
                  :href="accordion[isOpenIndex].card[0].cta.config.href"
                  :data-ga-name="accordion[isOpenIndex].card[0].cta.config.dataGaName"
                  :data-ga-location="accordion[isOpenIndex].card[0].cta.config.dataGaLocation"
                >
                  {{ accordion[isOpenIndex].card[0].cta.text }}
                  <SlpIcon :icon="ChevronLgRight" size="sm" />
                </SlpButton>
              </div>
            </Transition>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
#accordion-section {
  padding: 120px 0;
  background:
    linear-gradient(180deg, $color-surface-50, hsla(0, 0%, 100%, 0)),
    linear-gradient(126deg, #eee7fd, rgba(246, 243, 254, 0.83) 49.71%, rgba(255, 212, 216, 0.45));
}

.accordion {
  border-top: 3px solid #d1d0d3;
  animation: fade-in 0.5s ease-in forwards;

  &.active {
    border-top: 3px solid transparent;
    border-image: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%) 1;
    border-image-slice: 1;
    animation: fade-in 0.5s ease-in forwards;

    :deep(.summary-header) {
      color: $color-text-300;
    }
  }

  &__container {
    margin-top: $spacing-96;
    padding: 32px;
    display: flex;
    background: $color-surface-50;
    border-radius: 8px 8px 200px 8px;
  }

  &__wrapper {
    padding-right: 32px;
  }

  &__card {
    position: relative;
    min-height: 100%;
    padding: $spacing-32;
    background: linear-gradient(
      100.97deg,
      rgba(249, 160, 38, 0.1) -2.77%,
      rgba(166, 134, 242, 0.1) 82.08%,
      rgba(89, 42, 200, 0.1) 169.71%
    );
    border-radius: 8px 8px 170px 8px;
    flex: 2;

    .quote-body {
      font-size: 18px;
      line-height: 28px;
    }

    .logo {
      display: block;
      max-width: 160px;
      max-height: 80px;
      margin: $spacing-32 0;
    }
  }

  :deep(.summary-header) {
    margin: 32px 0;
    color: #74717a;
    font-size: 1.5rem;
    font-weight: 660;
    line-height: 1.17;
    letter-spacing: -0.02em;
    animation: fade-in 0.5s ease-in forwards;
  }

  :deep(.content p) {
    margin-bottom: 32px;
    font-size: 1.125rem;
    font-weight: 400;
    line-height: 1.56;
  }

  :deep(.accordion__icon) {
    color: Red;
    font-size: 30px;
    font-weight: 300;
  }
}

@keyframes fade-in {
  from {
    opacity: 0;
    transform: translateY(10px);
  }
  to {
    opacity: 1;
    transform: translateY(0);
  }
}
</style>
